
#include "xbasic_types.h"
#include "xio.h"
#include "font_8x8.h"

#define W 640
#define H 480
#define VGA_START 0x00800000

#define RED 0xE0
#define GREEN 0x1C
#define BLUE 0x03

void
draw_char (int x, int y, unsigned char ch)
{
  int row, col;
  short int row_template;

  // "Times 8" used  to  index  the //
  // array declared in "font_8x8.h" //
  int init_pos = ch * 8;

  // Print the 8 rows of the character //
  // in the outermost loop             //
  for (row = y; row < y + 8; row++)
  {
    // Read the character into a  short //
    // int variable to be able to shift //
    row_template = fontdata_8x8[row - y + init_pos];

    // Print each pixel that is 1 or 0 //
    // in  the  character's  template  //
    for (col = x; col < x + 8; col++)
    {
      // The varying  amount  of  shifting //
      // at each iteration takes  care  of //
      // analyzing the right bit at a time //
      if ((row_template << col-x) & 0x80)
      {
    	XIo_Out8(VGA_START + col + 640*row, RED|GREEN|BLUE);
      }
      // To take  care  of  cleaning  something //
      // already written (write the background) //
      else
      {
        XIo_Out8(VGA_START + col + 640*row, 0); 
      }
    }
  }
}

void draw_string(int x, int y, char *s)
{
  while(*s) draw_char(x+=8, y, *s++);
}

// This function can be used for debuging purposes //
void draw_hex(int x, int y, int n)
{
  int i, d;
  char c;
  for(i=0; i<8;i++){
    d=(n>>28)&0x0F;
    c = d>9 ? d-10+'A' : d+'0';
    draw_char(x+=8, y, c);
    n<<=4;
  }
}
